--- fai-3.2.4/bin/fai-class	2007-11-10 14:55:28.000000000 +0100
+++ fai-class.new	2008-02-15 09:43:50.000000000 +0100
@@ -49,13 +49,25 @@
 
     # append classes to a file
     while read line ; do
-	case $line in
-	\#*) ;; # strip comments
-	  *) debugmsg "Adding class $line"
-	     for class in $line ; do
-		 echo $class >> $filename
-	     done
-	esac
+        case $line in
+        \#*) ;; # strip comments
+          *) 
+             for class in $line ; do
+	         verbosemsg "I: Adding class $class"
+                 echo $class >> $filename
+
+		 if [[ -f $classdir/$class ]] ; then
+                     verbosemsg "I: File $classdir/$class found."
+		     if grep -q "^${class}$" $PARSEDCLASSES; then
+		        verbosemsg "W: $class already done. Not doing again."
+	             else
+		        verbosemsg "I: Recursively analyzing $class."
+			echo "$class" >> $PARSEDCLASSES
+	                grep -v "^#" "$classdir/$class" | addclass
+		     fi
+		 fi
+             done
+        esac
     done
 }
 # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
@@ -141,6 +158,9 @@
 setup "$@"
 verbosemsg "$0: Defining classes."
 
+# initialize $PARSEDCLASSES
+PARSEDCLASSES="/tmp/fai/parsed_classes"
+
 echo DEFAULT | addclass
 
 # define classes by executing scripts
@@ -192,6 +212,7 @@
 # add all classes which are listed in a file with the hostname
 if [ -f "$HOSTNAME" ]; then
 	verbosemsg "Using classes from file $classdir/$HOSTNAME"
+	echo "$HOSTNAME" >> $PARSEDCLASSES
 	grep -v "^#" $HOSTNAME | addclass
 fi
 
